#!/bin/sh

# Copyright (c) 2018-2022, diyIT.org
# All rights reserved.
#
# BSD 2-Clause License ("Simplified BSD License" or "FreeBSD License")
# https://diyit.org/license/
#
#

session="sess_tmux"

# set up tmux
tmux start-server

# create a new tmux session, naming the window freepbx
tmux new-session -d -s $session -n hass
tmux selectp -t 1
tmux send-keys "cd /mnt/config;./hass.sh" C-m

# create a new window windows
tmux new-window -t $session:1 -n heyu
tmux selectp -t 1
tmux send-keys "cd /mnt/config;./heyu.sh" C-m

# return to main window
tmux select-window -t $session:0
tmux selectp -t 1

# Finished setup, attach to the tmux session!
#tmux attach-session -t $session
