#!/bin/sh
#
# Copyright (c) 2018-2022, diyIT.org
# All rights reserved.
#
# BSD 2-Clause License ("Simplified BSD License" or "FreeBSD License")
# https://diyit.org/license/
#
#

session="emu_tmux"

# set up tmux
tmux start-server

# create a new tmux session, naming the window hercules
tmux new-session -d -s $session -n hercules
tmux selectp -t 1
tmux send-keys "cd /mnt/config;./ibm.sh" C-m

# create a new window empty
tmux new-window -t $session:1 -n empty
tmux selectp -t 1
tmux send-keys "cd /mnt/config;clear" C-m

# return to main window
tmux select-window -t $session:0
tmux selectp -t 1

# Finished setup, attach to the tmux session!
#tmux attach-session -t $session
