#!/bin/sh

# Copyright (c) 2018-2022, diyIT.org
# All rights reserved.
#
# BSD 2-Clause License ("Simplified BSD License" or "FreeBSD License")
# https://diyit.org/license/
#
#

session="vm_tmux"

# set up tmux
tmux start-server

# create a new tmux session, naming the window freepbx
tmux new-session -d -s $session -n freepbx
tmux selectp -t 1
tmux send-keys "cd /mnt/config;./pbx.sh" C-m

# create a new window windows
tmux new-window -t $session:1 -n windows
tmux selectp -t 1
tmux send-keys "cd /mnt/config;./windows.sh" C-m

# create a new window ubuntu
tmux new-window -t $session:2 -n ubuntu
tmux selectp -t 1
tmux send-keys "cd /mnt/config;./ubuntu.sh" C-m

# create a new window freebsd
tmux new-window -t $session:3 -n freebsd
tmux selectp -t 1
tmux send-keys "cd /mnt/config;./freebsd.sh" C-m

# create a new window w2019
tmux new-window -t $session:4 -n w2019
tmux selectp -t 1
tmux send-keys "cd /mnt/config;./w2019.sh" C-m

# create a new window r-windows
tmux new-window -t $session:5 -n r-windows
tmux selectp -t 1
tmux send-keys "cd /mnt/config;./r-windows.sh" C-m

# create a new window gns3
tmux new-window -t $session:6 -n gns3
tmux selectp -t 1
tmux send-keys "cd /mnt/config;./gns3.sh" C-m

# create a new window cvm-a
tmux new-window -t $session:7 -n cvm-a
tmux selectp -t 1
tmux send-keys "cd /mnt/config;./cvm-a.sh" C-m

# create a new window cvm-b
tmux new-window -t $session:8 -n cvm-b
tmux selectp -t 1
tmux send-keys "cd /mnt/config;./cvm-b.sh" C-m

# return to main window
tmux select-window -t $session:0
tmux selectp -t 1

# Finished setup, attach to the tmux session!
#tmux attach-session -t $session
